//-< HASHT.HPP >-----------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET   *     ?  *
// ( Garret object oriented data storage )                           *   /\|  *
// Macros to work with hash table                                    *  /  \  *
//                           Created:      26-Oct-92   K.A. Knizhnik * / [] \ *
//                           Last update:  26-Oct-92   K.A. Knizhnik * GARRET *
//-------------------------------------------------------------------*--------*

#ifndef __HASHT_HPP__
 #define __HASHT_HPP__

 #define   Hash_Elem( Class )   Class *Forward, **Backward

 #ifdef __MSDOS__
    inline tiny Hash_Coding ( large x ) {
       return *(tiny*)&x ^ *((tiny*)&x+1) ^ *((tiny*)&x+2) ^ *((tiny*)&x+3) ;
    }
 #else
    inline large Hash_Coding ( large x ) {
      large y = x ;
      return  y ^= x >>= 8, y ^= x >>= 8, y ^= x >>= 8 ;
    }
 #endif

 #define   Hash_Insert( Chain, Elem ) \
   ((Elem)->Forward = *Chain)->Backward = &(Elem)->Forward ; \
   *( (Elem)->Backward = Chain ) = Elem

 #define   Hash_Remove( Elem ) \
   (*(Elem)->Backward = (Elem)->Forward)->Backward = (Elem)->Backward


 #define   Hash_Next( Elem )  &(Elem)->Forward

 inline    void Hash_Set ( void* Table, void* Barrier, int Size ) {
   void **Dst = (void**) Table ;
   while ( Size -- ) *Dst++ = Barrier ;
 }

#endif
